package me.unurled.raxen.commands.admin;

import static me.unurled.raxen.utils.Utils.*;

import java.util.List;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.gui.ItemListGui;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class ItemListCommand implements TabExecutor {

  private Raxen main;

  @Getter
  private ItemListGui itemListGui;

  public ItemListCommand(Raxen main) {
    this.main = main;
    this.itemListGui = new ItemListGui(this.main);
  }

  @Override
  public boolean onCommand(
    @NotNull CommandSender sender,
    @NotNull Command cmd,
    @NotNull String msg,
    @NotNull String[] args
  ) {
    if (!(sender instanceof Player)) {
      log("Console can't execute this command atm.");
      return true;
    }
    Player player = (Player) sender;
    if (!(player.hasPermission("raxen.itemlist.cmd"))) {
      msgPlayer(
        player,
        colorString(
          "<red>You'dont have the permission to execute this command."
        )
      );
      return true;
    }
    //openGui logic
    player.openInventory(itemListGui.getInv());
    return false;
  }

  @Override
  public @Nullable List<String> onTabComplete(
    @NotNull CommandSender sender,
    @NotNull Command command,
    @NotNull String alias,
    @NotNull String[] args
  ) {
    return null;
  }
}
