package me.unurled.raxen.commands.player;

import static me.unurled.raxen.utils.Utils.errorConsoleSender;
import static me.unurled.raxen.utils.Utils.noPerms;

import java.util.List;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.gui.MainGui;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class MainGuiCommand implements TabExecutor {

  private Raxen main;

  public MainGuiCommand(Raxen main) {
    this.main = main;
  }

  /**
   * @param sender  Source of the command
   * @param command Command which was executed
   * @param label   Alias of the command which was used
   * @param args    Passed command arguments
   * @return
   */
  @Override
  public boolean onCommand(
    @NotNull CommandSender sender,
    @NotNull Command command,
    @NotNull String label,
    @NotNull String[] args
  ) {
    if (!(sender instanceof Player)) {
      errorConsoleSender(sender);
      return true;
    }
    Player p = (Player) sender;
    if (!(p.hasPermission("raxen.maingui.cmd"))) {
      sender.sendMessage(noPerms());
      return true;
    }
    Inventory inv = MainGui.build(p);
    p.openInventory(inv);
    return true;
  }

  /**
   * @param sender  Source of the command.  For players tab-completing a
   *                command inside of a command block, this will be the player, not
   *                the command block.
   * @param command Command which was executed
   * @param label   Alias of the command which was used
   * @param args    The arguments passed to the command, including final
   *                partial argument to be completed
   * @return
   */
  @Override
  public @Nullable List<String> onTabComplete(
    @NotNull CommandSender sender,
    @NotNull Command command,
    @NotNull String label,
    @NotNull String[] args
  ) {
    return null;
  }
}
