package me.unurled.raxen.components.entity.other;

import static me.unurled.raxen.utils.Utils.debug;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.entity.LivingEntity;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;

public class EntityUtils {

  private static Raxen main;
  private static EntityNamespacedKey namespacedKey;

  public EntityUtils(Raxen main) {
    this.main = main;
    namespacedKey = new EntityNamespacedKey(main);
  }

  public static void setNameSpacedKeys(
    org.bukkit.entity.@NotNull Entity e,
    String name,
    Integer level,
    int health,
    int itemHealth,
    int defense,
    int itemDefense,
    int speed,
    int itemSpeed,
    int strength,
    int itemDmg
  ) {
    PersistentDataContainer data = e.getPersistentDataContainer();
    data.set(namespacedKey.health, PersistentDataType.INTEGER, health);
    data.set(namespacedKey.itemHealth, PersistentDataType.INTEGER, itemHealth);
    data.set(namespacedKey.speed, PersistentDataType.INTEGER, speed);
    data.set(namespacedKey.itemSpeed, PersistentDataType.INTEGER, itemSpeed);
    data.set(namespacedKey.defense, PersistentDataType.INTEGER, defense);
    data.set(
      namespacedKey.itemDefense,
      PersistentDataType.INTEGER,
      itemDefense
    );
    data.set(namespacedKey.strength, PersistentDataType.INTEGER, strength);
    data.set(namespacedKey.itemStrength, PersistentDataType.INTEGER, itemDmg);
    data.set(namespacedKey.name, PersistentDataType.STRING, name);
    data.set(namespacedKey.level, PersistentDataType.INTEGER, level);
  }

  public static void updateSkills(@NotNull LivingEntity livingEntity) {
    PlayerManager pm =
      ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager()
        .getPlayerManager();
    int maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemStrength, maxMana, mana, itemMana, luck, itemLuck;
    defense = pm.getDefense().get(livingEntity);
    maxMana = pm.getMaxMana().get(livingEntity);
    itemDefense = pm.getItemDefense().get(livingEntity);
    health = pm.getHealth().get(livingEntity);
    itemHealth = pm.getItemHealth().get(livingEntity);
    mana = pm.getMana().get(livingEntity);
    speed = pm.getSpeed().get(livingEntity);
    itemLuck = pm.getItemLuck().get(livingEntity);
    strength = pm.getStrength().get(livingEntity);
    luck = pm.getLuck().get(livingEntity);
    maxHealth = pm.getMaxHealth().get(livingEntity);
    itemStrength = pm.getItemStrength().get(livingEntity);
    itemSpeed = pm.getItemSpeed().get(livingEntity);
    itemMana = pm.getItemMana().get(livingEntity);
    if (
      livingEntity.getAttribute(
        org.bukkit.attribute.Attribute.GENERIC_FLYING_SPEED
      ) !=
      null
    ) {
      livingEntity
        .getAttribute(org.bukkit.attribute.Attribute.GENERIC_FLYING_SPEED)
        .setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
    }
    if (
      livingEntity.getAttribute(
        org.bukkit.attribute.Attribute.GENERIC_MOVEMENT_SPEED
      ) !=
      null
    ) {
      livingEntity
        .getAttribute(org.bukkit.attribute.Attribute.GENERIC_MOVEMENT_SPEED)
        .setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
    }
    livingEntity
      .getAttribute(org.bukkit.attribute.Attribute.GENERIC_MAX_HEALTH)
      .setBaseValue(20D + (health + itemHealth) / 100);
    debug(
      "Entity " + livingEntity.getType().name(),
      "Speed " + (speed + itemSpeed),
      "Health " + (health + itemHealth) + " Max Health " + maxHealth,
      "Defense " + (defense + itemDefense),
      "Strength " + (strength + itemStrength),
      "Luck " + (luck + itemLuck),
      "Mana " + (mana + itemMana) + " Max Mana " + maxMana
    );
  }
}
