package me.unurled.raxen.components.items.abilities.weapon;

import java.util.ArrayList;
import me.unurled.raxen.utils.RayTrace;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.util.BoundingBox;
import org.bukkit.util.Vector;

public class ThrowingDagger {

  Player player;
  ItemStack item;
  Location start;

  public ThrowingDagger(Player p) {
    this.player = p;
    this.item = p.getActiveItem();
    this.start = p.getLocation();
  }

  public void throwDagger() {
    // ability throw a dagger in the direction the player is looking, max 20 blocks
    RayTrace rayTrace = new RayTrace(
      player.getEyeLocation().toVector(),
      player.getEyeLocation().getDirection()
    );
    ArrayList<Vector> positions = rayTrace.traverse(10, 0.01);
    for (int i = 0; i < positions.size(); i++) {
      Location position = positions.get(i).toLocation(player.getWorld());
      Block block = player.getWorld().getBlockAt(position);

      if (
        block != null &&
        block.getType() != Material.AIR &&
        rayTrace.intersects(BoundingBox.of(block), 10, 0.01)
      ) {
        player.sendMessage(block.getType().toString());
        break;
      }
    }
    /*for (int i = 0 ; i < 20 ; i++) {
            // spawn an item in air
            // dispawn the last one
            // repeat
        }*/
  }
}
