package me.unurled.raxen.listener.player;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.PlayerUtils;
import me.unurled.raxen.components.entity.player.Scoreboard;
import me.unurled.raxen.components.resourcepack.ResourcePack;
import me.unurled.raxen.config.PlayerConfig;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

public class JoinEvent implements Listener {

  private Raxen main;
  private PlayerConfig playerConfig;
  private Scoreboard scoreboard;
  private ResourcePack resourcePack;
  private PlayerManager playerManager;

  public JoinEvent(Raxen main) {
    this.main = main;
    this.playerConfig = main.getPlayerConfig();
    this.scoreboard = new Scoreboard(main);
    this.resourcePack =
      main.getManager().getResourcePackManager().getResourcePack();
    this.playerManager = main.getManager().getPlayerManager();
  }

  /**
   * when player joins, load from config all stats
   * @param e
   */
  @EventHandler
  public void PlayerJoinEvent(PlayerJoinEvent e) {
    Player player = e.getPlayer();
    playerConfig.loadPlayerConfig(player);
    scoreboard.createScorebord(player);
    resourcePack.join(player);
    playerManager.getRaxenPlayer(player).isRaxenPlayer(true);
    playerManager.registerActionBar(player);
    PlayerUtils.updateSkills(main, player);
  }
}
