package me.unurled.raxen.listener.player;

import static me.unurled.raxen.utils.Utils.colorTextComp;

import lombok.Getter;
import lombok.Setter;
import me.unurled.raxen.Raxen;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.server.ServerListPingEvent;

public class ServerPingEvent implements Listener {

  private Raxen main;

  @Getter
  @Setter
  private boolean loading = false;

  public ServerPingEvent(Raxen main) {
    this.main = main;
    this.loading = true;
  }

  /**
   * set the motd
   * @param e
   */
  @EventHandler
  public void ServerListPingEvent(ServerListPingEvent e) {
    FileConfiguration config = this.main.getConfig();
    String motd = config.getString("motd");
    String motdReload = config.getString("motd-reload");
    if (loading) {
      e.motd(colorTextComp(motdReload));
    } else {
      e.motd(colorTextComp(motd));
    }
  }
}
