package me.unurled.raxen.manager.server;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.commands.RaxenCommand;
import me.unurled.raxen.commands.admin.*;
import me.unurled.raxen.commands.player.ClassCommand;
import me.unurled.raxen.commands.player.MainGuiCommand;
import me.unurled.raxen.commands.player.SkillsCommand;
import me.unurled.raxen.commands.player.StorageCommand;

public class CommandManager {

  private Raxen main;

  @Getter
  private ItemListCommand itemListCommand;

  private ReloadCommand reloadComand = new ReloadCommand();
  private NbtCommand nbtCommand;
  private TestGuiCommand testGuiCommand = new TestGuiCommand();
  private StorageCommand storageCommand = new StorageCommand();
  private SkillsCommand skillsCommand;
  private RaxenCommand raxenCommand;
  private SpawnEntity entityspawn;
  private EntitiyCommand entitiyCommand;
  private ClassCommand classCommand;
  private CustomModelDataCommand customModelDataCommand;
  private MainGuiCommand mainGuiCommand;
  private ItemTo64Command itemTo64Command;

  public CommandManager(Raxen main) {
    this.main = main;
    this.itemListCommand = new ItemListCommand(this.main);
    this.nbtCommand = new NbtCommand(this.main);
    this.entityspawn = new SpawnEntity(this.main);
    this.entitiyCommand = new EntitiyCommand();
    this.classCommand = new ClassCommand(this.main);
    this.skillsCommand = new SkillsCommand(this.main);
    this.raxenCommand = new RaxenCommand(this.main);
    this.customModelDataCommand = new CustomModelDataCommand();
    this.mainGuiCommand = new MainGuiCommand(this.main);
    this.itemTo64Command = new ItemTo64Command();
  }

  /**
   * register/add all the plugin's command
   */
  public void register() {
    main.getCommand("reloadplugin").setExecutor(reloadComand);
    main.getCommand("reloadplugin").setTabCompleter(reloadComand);

    main.getCommand("nbt").setExecutor(nbtCommand);
    main.getCommand("nbt").setTabCompleter(nbtCommand);

    main.getCommand("testgui").setExecutor(testGuiCommand);
    main.getCommand("testgui").setTabCompleter(testGuiCommand);

    main.getCommand("storage").setExecutor(storageCommand);
    main.getCommand("storage").setTabCompleter(storageCommand);

    main.getCommand("skills").setTabCompleter(skillsCommand);
    main.getCommand("skills").setExecutor(skillsCommand);

    main.getCommand("raxen").setTabCompleter(raxenCommand);
    main.getCommand("raxen").setExecutor(raxenCommand);

    main.getCommand("itemlist").setExecutor(itemListCommand);
    main.getCommand("itemlist").setTabCompleter(itemListCommand);

    main.getCommand("entityspawn").setTabCompleter(entityspawn);
    main.getCommand("entityspawn").setExecutor(entityspawn);

    main.getCommand("class").setTabCompleter(classCommand);
    main.getCommand("class").setExecutor(classCommand);

    main.getCommand("custommodeldata").setTabCompleter(customModelDataCommand);
    main.getCommand("custommodeldata").setExecutor(customModelDataCommand);

    main.getCommand("main_gui").setTabCompleter(mainGuiCommand);
    main.getCommand("main_gui").setExecutor(mainGuiCommand);

    main.getCommand("itemto64").setTabCompleter(itemTo64Command);
    main.getCommand("itemto64").setExecutor(itemTo64Command);
  }
}
