package me.unurled.raxen.manager.server;

import static me.unurled.raxen.utils.Utils.debug;
import static me.unurled.raxen.utils.Utils.error;

import java.util.Objects;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.resourcepack.ResourcePack;
import org.bukkit.configuration.file.FileConfiguration;

public class ResourcePackManager {

  private Raxen main;

  @Getter
  private ResourcePack resourcePack;

  private FileConfiguration config;

  @Getter
  private boolean useRP;

  public ResourcePackManager(Raxen main) {
    this.main = main;
    this.resourcePack = new ResourcePack(main, this);
    this.config = main.getConfig();
    this.useRP = this.config.getBoolean("useResourcePack");
    enable();
  }

  /**
   * Method to enable the ressourcepack
   */
  private void enable() {
    if (useRP) {
      if (
        config.getString("resource_pack_url") == null ||
        Objects.equals(config.getString("rssource_pack_url"), "") ||
        config.getString("resource_pack_sha1") == null ||
        Objects.equals(config.getString("resource_pack_sha1"), "") ||
        Objects.equals(
          config.getString("resource_pack_url"),
          "https://mc-packs.net/"
        ) ||
        Objects.equals(config.getString("resource_pack_sha1"), "sha1hallo")
      ) {
        error(
          main,
          "You must specify an resource_pack_url and resource_pack_sha1!"
        );
        debug(main, "Resource pack not enabled.");
        useRP = false;
      } else {
        debug(main, "Ressource Pack enabled.");
      }
    } else {
      debug(main, "Resource pack not enabled.");
    }
  }
}
