package me.unurled.raxen.utils;

import static me.unurled.raxen.utils.Utils.colorTextComp;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import me.unurled.raxen.Raxen;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.server.ServerListPingEvent;

public class Reload implements Listener {

  private static FileConfiguration config = Objects
    .requireNonNull(Bukkit.getPluginManager().getPlugin("Raxen"))
    .getConfig();
  private static boolean serverReloading = true;

  /**
   * kick all online players
   */
  public static void kickAll() {
    for (Player player : Bukkit.getOnlinePlayers()) {
      player.kick(
        colorTextComp(
          Raxen.getPrefix() +
          "\n<red>Server is Restarting</red>\n <red>Please Wait a few Minutes to reconnect.</red>"
        )
      );
    }
  }

  /**
   * change the server ping list
   * @param e the server ping list event
   */
  @EventHandler
  public static void pingList(ServerListPingEvent e) {
    try {
      setPingList(e);
    } catch (IOException ex) {
      throw new RuntimeException(ex);
    }
  }

  /**
   * update ping list
   * @param e the ping event
   * @throws IOException file writing
   */
  public static void setPingList(ServerListPingEvent e) throws IOException {
    if (serverReloading) {
      List<String> newLines = new ArrayList<>();
      for (String line : Files.readAllLines(
        Paths.get("server.properties"),
        StandardCharsets.UTF_8
      )) {
        if (line.contains("motd=")) {
          newLines.add("motd=" + config.get("motd-reload"));
        } else {
          newLines.add(line);
        }
      }
      Files.write(
        Paths.get("server.properties"),
        newLines,
        StandardCharsets.UTF_8
      );

      e.motd(Component.text((String) config.get("motd-reload")));
    } else {
      e.motd(Component.text((String) config.get("motd")));
    }
  }
}
