package me.unurled.raxen.utils.libs;

import static me.unurled.raxen.utils.Utils.*;

import com.mongodb.ConnectionString;
import com.mongodb.client.MongoClient;
import com.mongodb.client.MongoClients;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import java.util.Objects;
import java.util.logging.Level;
import java.util.logging.Logger;
import lombok.Getter;
import org.bson.Document;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

public class MongoDB {

  @Getter
  private MongoClient mongoClient;

  @Getter
  private MongoDatabase mongoDatabase;

  @Getter
  private MongoCollection<Document> mongoCollection;

  @Getter
  private MongoCollection<Document> mongoConfigs;

  public void connect() {
    FileConfiguration config = Objects
      .requireNonNull(Bukkit.getPluginManager().getPlugin("Raxen"))
      .getConfig();
    String uri = (String) config.get("url");
    assert uri != null;
    debug("URI " + uri);
    ConnectionString connectionString = new ConnectionString(uri);
    mongoClient = MongoClients.create(connectionString);
    mongoDatabase = mongoClient.getDatabase("Raxen");
    mongoCollection = mongoDatabase.getCollection("player");
    mongoConfigs = mongoDatabase.getCollection("config");

    Bukkit
      .getConsoleSender()
      .sendMessage(colorComp("<green>MongoDB connected!"));
  }

  public void close() {
    mongoClient.close();

    Bukkit
      .getConsoleSender()
      .sendMessage(colorComp("<red>MongoDB disconnected!"));
  }
}
